﻿var weddingDate = options.getValue("wedding_date");
var weddingTime = options.getValue("wedding_time");

var countdownActive = true;
var step = -1;
var countdownFormat = ": %H%h : %M%m : %S%s";
var completionMsg = ": 00h : 00m : 00s";
var timeoutTime;
var dateDiff;
var secs;
var prevDays;
var days;
var dynamicLink;
var weddingStreetWeddingsLink = "http://www.magnetstreet.com/store/home/market/517"

var monthArray = new Array("January","February","March","April","May","June","July","August","September","October","November","December");

function stopCountdown(){
  countdownActive = false;
}

function loadCountdown(){
  countdownActive = true;
  step = Math.ceil(step);
  if (step == 0)
    countdownActive = false;
  timeoutTime = (Math.abs(step)-1)*1000 + 957;
  var endDate = new Date(weddingDate);
  endDate.setHours(weddingTime)
  var currentDate = new Date();
  if(step > 0){
    dateDiff = new Date(currentDate - endDate);
  } else{
    dateDiff = new Date(endDate - currentDate);
  }
  secs = Math.floor(dateDiff.valueOf()/1000);
  countDown(secs);
}

function calculateTime(secs, num1, num2, padResult) {
  s = ((Math.floor(secs/num1))%num2).toString();
  if (padResult && s.length < 2)
    s = "0" + s;
  return s;
}

function countDown(seconds) {
  if (seconds < 0) {
    countdown_days.innerText = "0";
    countdown_time.innerText = completionMsg;
    return;
  }
  prevDays = days;
  days = calculateTime(seconds,86400,100000, false);

  var displayDate;
  
  if(days == 1){
    days_text.innerText = "day";
  } else {
    days_text.innerText = "days";
  }
  
  countdown_days.innerText = days;
  
  displayDate = countdownFormat.replace(/%H%/g, calculateTime(seconds,3600,24, true));
  displayDate = displayDate.replace(/%M%/g, calculateTime(seconds,60,60, true));
  displayDate = displayDate.replace(/%S%/g, calculateTime(seconds,1,60, true));

  countdown_time.innerText = displayDate;
  if (countdownActive)
    setTimeout("countDown(" + (seconds+step) + ")", timeoutTime);
}	

function getWeddingDate() {
  var convertedWedDate;
  var tempDate = new Date(weddingDate);
  var conv_date = tempDate.getDate();  
  var conv_month = monthArray[(tempDate.getMonth())]; 
  var conv_year = tempDate.getFullYear();
  
  wedding_date.innerText = conv_month + " " + conv_date + ", " + conv_year;
}

function onOpen() {
  weddingDate = (options.getValue("wedding_date") == "")? "" : options.getValue("wedding_date");
  weddingTime = (options.getValue("wedding_time") == "")? "" : options.getValue("wedding_time");
  if(weddingDate != "" && weddingDate != null && weddingTime != "" && weddingTime != null){
    stopCountdown();
    setTimeout("loadCountdown()", 1000);
    getWeddingDate();
  }
}

function onOptionChanged() {
  // optionChanged will contain the name of the option which was changed
  var optionChanged = event.propertyName;

  // Update only the appropriate option
  if (optionChanged == "wedding_date")
    weddingDate = options.getValue("wedding_date");
  if (optionChanged == "wedding_time"){
    weddingTime = options.getValue("wedding_time");
  }
  if(weddingDate != "" && weddingTime !=""){
    stopCountdown();
    setTimeout("loadCountdown()", 1000);
    getWeddingDate();
  }
}






